//---- indicator settings
#property  indicator_separate_window

#property  indicator_buffers 2
#property indicator_color1 SpringGreen
#property indicator_color2 Crimson

#property indicator_width1 2
#property indicator_width2 2

#property indicator_level1 0

//---- indicator parameters
extern int FastHMA = 9; 
extern int SlowHMA = 21; 
//---- indicator buffers
double	OsmaBuffer[];
double	PreHMA1[]; 
double	PreHMA2[]; 
double Uptrend[];
double Dntrend[];


//+------------------------------------------------------------------+
int pF, pS; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 4 additional buffers are used for counting.
   IndicatorBuffers(5);
   
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,SlowHMA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SlowHMA);

 //  SetIndexStyle(2,DRAW_LINE);
 //  SetIndexDrawBegin(2,SlowHMA);
   
   IndicatorDigits(Digits+2);
   
//---- 5 indicator buffers mapping
   SetIndexBuffer(0,Uptrend);
   SetIndexBuffer(1,Dntrend);
   SetIndexBuffer(2,OsmaBuffer);
   SetIndexBuffer(3,PreHMA1);
   SetIndexBuffer(4,PreHMA2);

//   SetIndexBuffer(2,PreHMA2);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OsHMA("+FastHMA+","+SlowHMA+")");
   
	pF = MathSqrt(FastHMA); 
	pS = MathSqrt(SlowHMA); 
	
//---- initialization done
   return(0);
  }

  
//+------------------------------------------------------------------+
double WMA(int x, int p) { 
	return(iMA(NULL, 0, p, 0, MODE_LWMA, PRICE_CLOSE, x)); 
} 

//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
   limit=Bars-counted_bars-1;
   
//---- preparing the HMA
   for(int i=limit; i>=0; i--) {
   	PreHMA1[i] = 2.0*WMA(i, FastHMA*0.5) - WMA(i, FastHMA); 
   	PreHMA2[i] = 2.0*WMA(i, SlowHMA*0.5) - WMA(i, SlowHMA); 
   }

//---- macd counted in the 1-st additional buffer
   for(i=limit; i>=0; i--)
   	OsmaBuffer[i]= iMAOnArray(PreHMA1, 0, pF, 0, MODE_LWMA, i) - iMAOnArray(PreHMA2, 0, pS, 0, MODE_LWMA, i);
 
   for(i=limit; i>=0; i--){
      Uptrend[i] = EMPTY_VALUE; 
      Dntrend[i] = EMPTY_VALUE; 
         if (OsmaBuffer[i]> OsmaBuffer[i+1]) {
            Uptrend[i+1] = OsmaBuffer[i+1]; Uptrend[i] = OsmaBuffer[i]; 
         }
         if (OsmaBuffer[i]< OsmaBuffer[i+1]) {
            Dntrend[i+1] = OsmaBuffer[i+1]; 
            Dntrend[i] = OsmaBuffer[i]; 
         }
   }    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

